; Copyright (C) 1995-1997 The Hungry Programmers - hungry@hungry.com
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


;;;;;;;;;
;; save
;;;;;;;;;

(define (actually-save-ascii file-name)
  (let* ((fp (open-file-for-save file-name)))
    (do ((con (container.first-lowest-container doc)
	      (container.next-node con)))
	((eqv? con #f) #t)
      (let ((s (container.get-leaf-ascii con)))
	(display s fp)))

    (close-output-port fp)))
	


(define (save-ascii doc)
  (save-file actually-save-ascii))


;;;;;;;;;
;; load
;;;;;;;;;

(define (actually-load-ascii file-name)

    ;; free old document here...

    (let* ((fp (open-file-for-load file-name))
	   (doc-style (car doc-styles))
	   (page-style (car page-styles))
	   (column-style (car column-styles))
	   (line-style (car line-styles-low))
	   (word-style (car word-styles))
	   (wordsegment-style (car wordsegment-styles))
	   (new-doc (document.new doc-style)))

      (container.insert-child (container.last-lowest-container new-doc) 0
			      (page.new page-style))

      (container.insert-child (container.last-lowest-container new-doc) 0
			      (container.new column-style))
      
      (container.insert-child (container.last-lowest-container new-doc) 0
			      (container.new line-style))
      
      (do ((parent (container.last-lowest-container new-doc))
	   (index 0 (+ index 1))
	   (input-line (read-line fp 'concat) (read-line fp 'concat)))
	  ;
	  ((eof-object? input-line) #t)
	;
	(let* ((line-length (string-length input-line))
	       (new-word (container.new word-style))
	       (new-wordsegment (wordsegment.new wordsegment-style)))
	  (container.set-leaf-ascii new-wordsegment input-line)
	  (container.insert-child new-word 0 new-wordsegment)
	  (container.insert-child parent index new-word)))

      (close-input-port fp)

      (xword-window.set-doc xw new-doc)

      (xword-window.set-cursor-position
       xw
       (container.first-lowest-container new-doc)
       0)

      (xword-window.rewrap xw
			   (container.first-lowest-container new-doc)
			   (container.last-lowest-container new-doc))

      (xword-window.scroll-to-cursor xw)
      (xword-window.redraw xw new-doc)

      new-doc))


(define (load-ascii doc)
  (load-file actually-load-ascii))


;;;;;;;;;;;
;; insert
;;;;;;;;;;;

(define (actually-insert-ascii file-name)

  (let* ((fp (open-file-for-load file-name))
	 (doc-style (car doc-styles))
	 (page-style (car page-styles))
	 (column-style (car column-styles))
	 (line-style (car line-styles-low))
	 (word-style (car word-styles))
	 (wordsegment-style cur-attr))

    (do ((parent (container.get-parent
		  (container.get-parent
		   (car (xword-window.get-cursor-position xw)))))
	 (index 0 (+ index 1))
	 (input-line (read-line fp 'concat) (read-line fp 'concat)))
	;
	((eof-object? input-line) #t)
      ;
      (let* ((line-length (string-length input-line))
	     (new-word (container.new word-style))
	     (new-wordsegment (wordsegment.new wordsegment-style)))
	(container.set-leaf-ascii new-wordsegment input-line)
	(container.insert-child new-word 0 new-wordsegment)
	(container.insert-child parent index new-word)))
      
    (close-input-port fp)
      
    (xword-window.set-cursor-position
     xw
     (container.first-lowest-container doc)
     0)
      
    (xword-window.rewrap xw
			 (container.first-lowest-container doc)
			 (container.last-lowest-container doc))
      
    (xword-window.scroll-to-cursor xw)
    (xword-window.redraw xw doc)
    doc))


(define (insert-ascii doc)
  (load-file actually-insert-ascii))
