; Copyright (C) 1995-1997 The Hungry Programmers - hungry@hungry.com
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



;; code shared by all the save and load routines

(define (save-fsb-ok widget client-data call-data)
  (xt-popdown fsb-shell)

  (if #f ; make #t to disable the error handler, #f to enable

      (actually-save widget client-data call-data)

      (begin
	(let* ((can-save #t)
	       (handler
		(lambda (key args . rest)
		  (set! can-save #f)
		  key))
	       (blah (catch #t
			    (lambda ()
			      (actually-save widget client-data call-data))
			    handler)))

	  (cond ((eq? can-save #f)
		 (display "can't save ")
		 (display (fsb-get-file-name widget))
		 (newline)
		 (display "exception: ")
		 (display blah)
		 (newline)))))))


(define (actually-save widget client-data call-data)
  (let* ((file-name (fsb-get-file-name widget)))
    ;(display "file name is ") (display file-name) (newline)

    (client-data file-name)))

    ;(close-output-port fp)))
	

(define (open-file-for-save file-name)
  (if (file-exists? file-name)
      (begin
	(display "need overwrite? dialog.")
	(newline)))

  (let* ((fp (false-if-exception (open-file file-name "w"))))
    (if (eq? fp #f)
	(begin
	  (display "can't open file ")
	  (display file-name)
	  (display "for writing")
	  (newline)
	  (error "can't save.")))

    fp))
  


(define (save-fsb-cancel widget client-data call-data)
  (xt-popdown fsb-shell))


(define (save-file saver)
  (show-fsb)
  (xt-remove-all-callbacks fsb (xm-n-ok-callback))
  (xt-remove-all-callbacks fsb (xm-n-cancel-callback))
  (xt-add-callback fsb (xm-n-ok-callback) save-fsb-ok (list saver))
  (xt-add-callback fsb (xm-n-cancel-callback) save-fsb-cancel (list #f)))


;;;;;;;;;;
;;; load
;;;;;;;;;;


(define (load-fsb-ok widget client-data call-data)
  (xt-popdown fsb-shell)

  (if #f ; make #t to disable the error handler, #f to enable

      (actually-load widget client-data call-data)

      (begin
	(let* ((can-load #t)
	       (handler
		(lambda (key args . rest)
		  (set! can-load #f)
		  key))
	       (blah (catch #t
			    (lambda ()
			      (actually-load widget client-data call-data))
			    handler)))

	  (cond ((eq? can-load #f)
		 (display "can't load ")
		 (display (fsb-get-file-name widget))
		 (newline)
		 (display "exception: ")
		 (display blah)
		 (newline))
		(else
		 (set! doc blah)))))))


(define (actually-load widget client-data call-data)
  (let* ((file-name (fsb-get-file-name widget)))
    (client-data file-name)))


(define (open-file-for-load file-name)

  (if (not (file-exists? file-name))

      (begin
	(display "no such file: ")
	(display file-name)
	(newline)
	(error "can't load.")
	#f)

      (let* ((fp (false-if-exception (open-file file-name "r"))))
	(if (eq? fp #f)
	    (begin
	      (display "can't open file ")
	      (display file-name)
	      (display "for reading")
	      (newline)
	      (error "can't load.")))

	fp)))


(define (load-fsb-cancel widget client-data call-data)
  (xt-popdown fsb-shell))


(define (load-file loader)
  (show-fsb)
  (xt-remove-all-callbacks fsb (xm-n-ok-callback))
  (xt-remove-all-callbacks fsb (xm-n-cancel-callback))
  (xt-add-callback fsb (xm-n-ok-callback) load-fsb-ok (list loader))
  (xt-add-callback fsb (xm-n-cancel-callback) load-fsb-cancel (list #f)))
