; Copyright (C) 1995-1997 The Hungry Programmers - hungry@hungry.com
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



(define search-shell #f)
(define search-form #f)
(define search-tf #f)
(define search-rc #f)
(define search-backward #f)
(define search-forward #f)
(define search-close #f)



(define (search-proc nxt)
  (let* ((cp (xword-window.get-cursor-position xw))
	 (cur (nxt (car cp)))
	 (tf-c-str (xt-get-value search-tf (xm-n-value)))
	 (tf-str (c-string-to-scm-string tf-c-str))
	 (len (length tf-str))
	 (c (do ((c cur (nxt c)))
		((or (eqv? c #f)
		     (let* ((str (container.get-leaf-ascii c)))
		       (if (>= (length str) len)
			   (string-ci=? tf-str (substring str 0 len))
			   #f)))
		 c))))
    (if (not (eqv? c #f))
	(begin
	  (xword-window.set-cursor-position xw c 0)
	  (xword-window.scroll-to-cursor xw)
	  (xword-window.redraw xw doc)))))


(define (search-backward-callback widget client-data call-data)
  (search-proc container.prev-node))

(define (search-forward-callback widget client-data call-data)
  (search-proc container.next-node))


(define (search-close-callback widget client-data call-data)
  (xt-popdown search-shell))


(define (open-search)
  (if (eqv? search-shell #f)
      (begin
	(set! search-shell (xt-app-create-shell xdisplay "search"))
	(set! search-form
	      (xt-create-widget "search form"
				(xm-form-widget-class) search-shell #f))
	(set! search-tf
	      (xt-create-widget "search tf"
				(xm-text-field-widget-class)
				search-form
				(list (list (xm-n-left-attachment)
					    (xm-attach-form))
				      (list (xm-n-top-attachment)
					    (xm-attach-form))
				      (list (xm-n-right-attachment)
					    (xm-attach-form))
				      (list (xm-n-bottom-attachment)
					    (xm-attach-none)))))
	(set! search-rc
	      (xt-create-widget "search rc"
				(xm-row-column-widget-class)
				search-form
				(list (list (xm-n-left-attachment)
					    (xm-attach-form))
				      (list (xm-n-top-attachment)
					    (xm-attach-widget))
				      (list (xm-n-top-widget)
					    search-tf)
				      (list (xm-n-right-attachment)
					    (xm-attach-form))
				      (list (xm-n-bottom-attachment)
					    (xm-attach-form))
				      (list (xm-n-orientation)
					    (xm-horizontal)))))

	(set! search-backward (xt-create-widget "<<"
						(xm-push-button-widget-class)
						search-rc #f))

	(set! search-forward (xt-create-widget ">>"
					       (xm-push-button-widget-class)
					       search-rc #f))

	(set! search-close (xt-create-widget "close"
					     (xm-push-button-widget-class)
					     search-rc #f))


	(xt-add-callback search-backward (xm-n-activate-callback)
			 search-backward-callback (list #t))

	(xt-add-callback search-forward (xm-n-activate-callback)
			 search-forward-callback (list #t))

	(xt-add-callback search-close (xm-n-activate-callback)
			 search-close-callback (list #t))


	(xt-manage-child search-tf)
	(xt-manage-child search-backward)
	(xt-manage-child search-forward)
	(xt-manage-child search-close)
	(xt-manage-child search-rc)
	(xt-manage-child search-form)
	(xt-realize-widget search-shell)))
  ;
  (xt-popup search-shell (xt-grab-none)))